Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.io.nio
Class ByteBufferWriteBuffer

`java.lang.Object
com.tangosol.io.AbstractWriteBuffer
com.tangosol.io.nio.ByteBufferWriteBuffer`

All Implemented Interfaces:
  WriteBuffer

      public final class ByteBufferWriteBuffer

extends AbstractWriteBuffer
implements WriteBuffer

A WriteBuffer implementation on top of a Java NIO ByteBuffer.

Author:
  cp 2006.04.05

Nested Class Summary
`class` | `ByteBufferWriteBuffer.ByteBufferOutput` This is a simple implementation of the BufferOutput interface on top of a ByteBuffer.

Nested classes/interfaces inherited from class com.tangosol.io.AbstractWriteBuffer
`AbstractWriteBuffer.AbstractBufferOutput`

Nested classes/interfaces inherited from interface com.tangosol.io.WriteBuffer
`WriteBuffer.BufferOutput`

Field Summary

Fields inherited from class com.tangosol.io.AbstractWriteBuffer
`CHAR_BUF_MASK, CHAR_BUF_SIZE, m_achBuf, NO_BINARY, NO_BYTES`

Constructor Summary
`ByteBufferWriteBuffer(ByteBuffer buf)` Construct a ByteBufferWriteBuffer on an NIO ByteBuffer.

Method Summary
`Object` | `clone()` Create a clone of this WriteBuffer object. Changes to the clone will not affect the original, and vice-versa.
`WriteBuffer.BufferOutput` | `getBufferOutput(int of)` Get a BufferOutput object to write data to this buffer starting at a particular offset. Note that each call to this method will return a new BufferOutput object, with the possible exception being that a zero-length non-resizing WriteBuffer could always return the same instance (since it is not writable). This is functionally equivalent to:
     BufferOutput bufout = getBufferOutput();
     bufout.setOffset(of);
     return bufout;
`ByteBuffer` | `getByteBuffer()` Obtain the ByteBuffer that this WriteBuffer is based on.
`int` | `getCapacity()` Determine the number of bytes that the buffer can hold without resizing itself. In other words, a WriteBuffer has `getCapacity() - `WriteBuffer.length()`` bytes that can be written to it without overflowing the current underlying buffer allocation. Since the buffer is an abstract concept, the actual mechanism for the underlying buffer is not known, but it could be a Java NIO buffer, or a byte array, etc. Note that if the maximum size returned by `WriteBuffer.getMaximumCapacity()` is greater than the current size returned by this method, then the WriteBuffer will automatically resize itself to allocate more space when the amount of data written to it passes the current size.
`ReadBuffer` | `getReadBuffer()` Get a ReadBuffer object that is a snapshot of this WriteBuffer's data. This method is functionally equivalent to the following code:
     ReadBuffer buf = getUnsafeReadBuffer();
     byte[] ab = buf.toByteArray();
     return new ByteArrayReadBuffer(ab);
`ReadBuffer` | `getUnsafeReadBuffer()` Get a ReadBuffer object to read data from this buffer. This method is not guaranteed to return a snapshot of this buffer's data, nor is it guaranteed to return a live view of this buffer, which means that subsequent changes to this WriteBuffer may or may not affect the contents and / or the length of the returned ReadBuffer. To get a snapshot, use the `WriteBuffer.getReadBuffer()` method.
`int` | `length()` Determine the length of the data that is in the buffer. This is the actual number of bytes of data that have been written to the buffer, not the capacity of the buffer.
`void` | `retain(int of, int cb)` Starting with the byte at offset `of`, retain `cb` bytes in this WriteBuffer, such that the byte at offset `of` is shifted to offset 0, the byte at offset `of + 1` is shifted to offset 1, and so on up to the byte at offset `of + cb - 1`, which is shifted to offset `cb - 1`. After this method, the length of the buffer as indicated by the `WriteBuffer.length()` method will be equal to `cb`. Legal values for the offset of the first byte to retain `of` are `(of >= 0 && of <= `WriteBuffer.length()`)`. Legal values for the number of bytes to retain `cb` are `(cb >= 0 && cb <= `WriteBuffer.length()`)`, such that `(of + cb <= `WriteBuffer.length()`)`. If `cb` is zero, then this method will have the same effect as clear. If `of` is zero, then this method will have the effect of truncating the data in the buffer, but no bytes will be shifted within the buffer. The effect on the capacity of the buffer is implementation-specific; some implementations are expected to retain the same capacity while others are expected to shrink accordingly.
`Binary` | `toBinary()` Returns a new Binary object that holds the complete contents of this WriteBuffer. This method is functionally equivalent to the following code:
     return getUnsafeReadBuffer().toBinary();
`byte[]` | `toByteArray()` Returns a new byte array that holds the complete contents of this WriteBuffer. This method is functionally equivalent to the following code:
     return getUnsafeReadBuffer().toByteArray();
`void` | `write(int ofDest, byte b)` Store the specified byte at the specified offset within the buffer. For purposes of side-effects and potential exceptions, this method is functionally equivalent to the following code:
     byte[] abSrc = new byte[1];
     abSrc[0] = b;
     write(ofDest, abSrc, 0, abSrc.length);
`void` | `write(int ofDest, byte[] abSrc, int ofSrc, int cbSrc)` Store the specified number of bytes from the specified location within the passed byte array at the specified offset within this buffer. As a result of this method, the buffer length as reported by the ``WriteBuffer.length()`` method will become `Math.max(`WriteBuffer.length()`, ofDest + cbSrc)`. As a result of this method, the buffer capacity as reported by the ``WriteBuffer.getCapacity()`` method will not change if the new value returned by ``WriteBuffer.length()`` would not exceed the old value returned by ``WriteBuffer.getCapacity()``; otherwise, the capacity will be increased such that ``WriteBuffer.getCapacity()` >= `WriteBuffer.length()``. Regardless, it is always true that ``WriteBuffer.getCapacity()` >= `WriteBuffer.length()`` and ``WriteBuffer.getMaximumCapacity()` >= `WriteBuffer.getCapacity()``. If the buffer capacity cannot be increased due to resource constraints, an undesignated Error or RuntimeException will be thrown, such as OutOfMemoryError.
`void` | `write(int ofDest, ReadBuffer bufSrc, int ofSrc, int cbSrc)` Store the specified portion of the contents of the specified ReadBuffer at the specified offset within this buffer. For purposes of side-effects and potential exceptions, this method is functionally equivalent to the following code:
     byte[] abSrc = bufSrc.toByteArray(ofSrc, cbSrc);
     write(ofDest, abSrc, 0, abSrc.length);

Methods inherited from class com.tangosol.io.AbstractWriteBuffer
`clear, copyBufferInputPortion, copyBufferInputRemainder, copyStream, getAppendingBufferOutput, getBufferOutput, getMaximumCapacity, getWriteBuffer, getWriteBuffer, releaseBuffers, retain, tmpbuf, tmpbuf, write, write, write, write`

Methods inherited from interface com.tangosol.io.WriteBuffer
`clear, getAppendingBufferOutput, getBufferOutput, getMaximumCapacity, getWriteBuffer, getWriteBuffer, retain, write, write, write, write`

Constructor Detail

### ByteBufferWriteBuffer

    public ByteBufferWriteBuffer(ByteBuffer buf)

  Construct a ByteBufferWriteBuffer on an NIO ByteBuffer.
  Parameters:
    `buf` - the underlying NIO ByteBuffer

Method Detail

### getByteBuffer

    public ByteBuffer getByteBuffer()

  Obtain the ByteBuffer that this WriteBuffer is based on.
  Returns:
    the underlying ByteBuffer

### write

    public void write(int ofDest,
                      byte b)

  Store the specified byte at the specified offset within the buffer.

  For purposes of side-effects and potential exceptions, this method is functionally equivalent to the following code:

       byte[] abSrc = new byte[1];
       abSrc[0] = b;
       write(ofDest, abSrc, 0, abSrc.length);

  Specified by:
    `write` in interface `WriteBuffer`
  Specified by:
    `write` in class `AbstractWriteBuffer`
  Parameters:
    `ofDest` - the offset within this buffer to store the passed data
    `b` - the byte to store in this buffer

### write

    public void write(int ofDest,
                      byte[] abSrc,
                      int ofSrc,
                      int cbSrc)

  Store the specified number of bytes from the specified location within the passed byte array at the specified offset within this buffer.

  As a result of this method, the buffer length as reported by the ``WriteBuffer.length()`` method will become `Math.max(`WriteBuffer.length()`, ofDest + cbSrc)`.

  As a result of this method, the buffer capacity as reported by the ``WriteBuffer.getCapacity()`` method will not change if the new value returned by ``WriteBuffer.length()`` would not exceed the old value returned by ``WriteBuffer.getCapacity()``; otherwise, the capacity will be increased such that ``WriteBuffer.getCapacity()` >= `WriteBuffer.length()``. Regardless, it is always true that ``WriteBuffer.getCapacity()` >= `WriteBuffer.length()`` and ``WriteBuffer.getMaximumCapacity()` >= `WriteBuffer.getCapacity()``. If the buffer capacity cannot be increased due to resource constraints, an undesignated Error or RuntimeException will be thrown, such as OutOfMemoryError.

  Specified by:
    `write` in interface `WriteBuffer`
  Specified by:
    `write` in class `AbstractWriteBuffer`
  Parameters:
    `ofDest` - the offset within this buffer to store the passed data
    `abSrc` - the array containing the bytes to store in this buffer
    `ofSrc` - the offset within the passed byte array to copy from
    `cbSrc` - the number of bytes to copy from the passed byte array

### write

    public void write(int ofDest,
                      ReadBuffer bufSrc,
                      int ofSrc,
                      int cbSrc)

  Store the specified portion of the contents of the specified ReadBuffer at the specified offset within this buffer.

  For purposes of side-effects and potential exceptions, this method is functionally equivalent to the following code:

       byte[] abSrc = bufSrc.toByteArray(ofSrc, cbSrc);
       write(ofDest, abSrc, 0, abSrc.length);

  Specified by:
    `write` in interface `WriteBuffer`
  Overrides:
    `write` in class `AbstractWriteBuffer`
  Parameters:
    `ofDest` - the offset within this buffer to store the passed data
    `bufSrc` - the array of bytes to store in this buffer
    `ofSrc` - the offset within the passed ReadBuffer to copy from
    `cbSrc` - the number of bytes to copy from the passed ReadBuffer

### length

    public int length()

  Determine the length of the data that is in the buffer. This is the actual number of bytes of data that have been written to the buffer, not the capacity of the buffer.
  Specified by:
    `length` in interface `WriteBuffer`
  Specified by:
    `length` in class `AbstractWriteBuffer`
  Returns:
    the number of bytes of data represented by this WriteBuffer

### retain

    public void retain(int of,
                       int cb)

  Starting with the byte at offset `of`, retain `cb` bytes in this WriteBuffer, such that the byte at offset `of` is shifted to offset 0, the byte at offset `of + 1` is shifted to offset 1, and so on up to the byte at offset `of + cb - 1`, which is shifted to offset `cb - 1`. After this method, the length of the buffer as indicated by the `WriteBuffer.length()` method will be equal to `cb`.

  Legal values for the offset of the first byte to retain `of` are `(of >= 0 && of <= `WriteBuffer.length()`)`. Legal values for the number of bytes to retain `cb` are `(cb >= 0 && cb <= `WriteBuffer.length()`)`, such that `(of + cb <= `WriteBuffer.length()`)`.

  If `cb` is zero, then this method will have the same effect as clear. If `of` is zero, then this method will have the effect of truncating the data in the buffer, but no bytes will be shifted within the buffer.

  The effect on the capacity of the buffer is implementation-specific; some implementations are expected to retain the same capacity while others are expected to shrink accordingly.

  Specified by:
    `retain` in interface `WriteBuffer`
  Specified by:
    `retain` in class `AbstractWriteBuffer`
  Parameters:
    `of` - the offset of the first byte within the WriteBuffer that will be retained
    `cb` - the number of bytes to retain

### getCapacity

    public int getCapacity()

  Determine the number of bytes that the buffer can hold without resizing itself. In other words, a WriteBuffer has `getCapacity() - `WriteBuffer.length()`` bytes that can be written to it without overflowing the current underlying buffer allocation. Since the buffer is an abstract concept, the actual mechanism for the underlying buffer is not known, but it could be a Java NIO buffer, or a byte array, etc.

  Note that if the maximum size returned by `WriteBuffer.getMaximumCapacity()` is greater than the current size returned by this method, then the WriteBuffer will automatically resize itself to allocate more space when the amount of data written to it passes the current size.

  Specified by:
    `getCapacity` in interface `WriteBuffer`
  Specified by:
    `getCapacity` in class `AbstractWriteBuffer`
  Returns:
    the number of bytes of data that this WriteBuffer can hold without resizing its underlying buffer

### getBufferOutput

    public WriteBuffer.BufferOutput getBufferOutput(int of)

  Get a BufferOutput object to write data to this buffer starting at a particular offset.

  Note that each call to this method will return a new BufferOutput object, with the possible exception being that a zero-length non-resizing WriteBuffer could always return the same instance (since it is not writable).

  This is functionally equivalent to:

       BufferOutput bufout = getBufferOutput();
       bufout.setOffset(of);
       return bufout;

  Specified by:
    `getBufferOutput` in interface `WriteBuffer`
  Overrides:
    `getBufferOutput` in class `AbstractWriteBuffer`
  Parameters:
    `of` - the offset of the first byte of this buffer that the BufferOutput will write to
  Returns:
    a BufferOutput that will write to this buffer

### getReadBuffer

    public ReadBuffer getReadBuffer()

  Get a ReadBuffer object that is a snapshot of this WriteBuffer's data.

  This method is functionally equivalent to the following code:

       ReadBuffer buf = getUnsafeReadBuffer();
       byte[] ab = buf.toByteArray();
       return new ByteArrayReadBuffer(ab);

  Specified by:
    `getReadBuffer` in interface `WriteBuffer`
  Overrides:
    `getReadBuffer` in class `AbstractWriteBuffer`
  Returns:
    a ReadBuffer that reflects the point-in-time contents of this WriteBuffer

### getUnsafeReadBuffer

    public ReadBuffer getUnsafeReadBuffer()

  Get a ReadBuffer object to read data from this buffer. This method is not guaranteed to return a snapshot of this buffer's data, nor is it guaranteed to return a live view of this buffer, which means that subsequent changes to this WriteBuffer may or may not affect the contents and / or the length of the returned ReadBuffer.

  To get a snapshot, use the `WriteBuffer.getReadBuffer()` method.

  Specified by:
    `getUnsafeReadBuffer` in interface `WriteBuffer`
  Specified by:
    `getUnsafeReadBuffer` in class `AbstractWriteBuffer`
  Returns:
    a ReadBuffer that reflects the contents of this WriteBuffer but whose behavior is undefined if the WriteBuffer is modified

### toByteArray

    public byte[] toByteArray()

  Returns a new byte array that holds the complete contents of this WriteBuffer.

  This method is functionally equivalent to the following code:

       return getUnsafeReadBuffer().toByteArray();

  Specified by:
    `toByteArray` in interface `WriteBuffer`
  Overrides:
    `toByteArray` in class `AbstractWriteBuffer`
  Returns:
    the contents of this WriteBuffer as a byte[]

### toBinary

    public Binary toBinary()

  Returns a new Binary object that holds the complete contents of this WriteBuffer.

  This method is functionally equivalent to the following code:

       return getUnsafeReadBuffer().toBinary();

  Specified by:
    `toBinary` in interface `WriteBuffer`
  Overrides:
    `toBinary` in class `AbstractWriteBuffer`
  Returns:
    the contents of this WriteBuffer as a Binary object

### clone

    public Object clone()

  Create a clone of this WriteBuffer object. Changes to the clone will not affect the original, and vice-versa.
  Specified by:
    `clone` in interface `WriteBuffer`
  Overrides:
    `clone` in class `AbstractWriteBuffer`
  Returns:
    a WriteBuffer object with the same contents as this WriteBuffer object

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.0.0 E15725-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.